>From 07e1f5419c979358d2e09cdcb363cd785b96d94a Mon Sep 17 00:00:00 2001
From: Abhishek Koneru <akoneru@redhat.com>
Date: Mon, 8 Apr 2013 14:32:12 -0400
Subject: [PATCH] Remove [OPTIONS] from usage in commands with no options.

Remove the text [OPTIONS]... in user-show message, which misleads
that there are other optional arguements.

Ticket #543
---
 .../src/com/netscape/cmstools/cert/CertRequestShowCLI.java           |    2 +-
 .../src/com/netscape/cmstools/group/GroupAddMemberCLI.java           |    2 +-
 base/java-tools/src/com/netscape/cmstools/group/GroupRemoveCLI.java  |    2 +-
 .../src/com/netscape/cmstools/group/GroupRemoveMemberCLI.java        |    2 +-
 base/java-tools/src/com/netscape/cmstools/group/GroupShowCLI.java    |    2 +-
 .../src/com/netscape/cmstools/group/GroupShowMemberCLI.java          |    2 +-
 .../netscape/cmstools/system/SecurityDomainGetInstallTokenCLI.java   |    2 +-
 .../src/com/netscape/cmstools/user/UserAddMembershipCLI.java         |    2 +-
 base/java-tools/src/com/netscape/cmstools/user/UserRemoveCLI.java    |    2 +-
 .../java-tools/src/com/netscape/cmstools/user/UserRemoveCertCLI.java |    2 +-
 .../src/com/netscape/cmstools/user/UserRemoveMembershipCLI.java      |    2 +-
 base/java-tools/src/com/netscape/cmstools/user/UserShowCLI.java      |    2 +-
 12 files changed, 12 insertions(+), 12 deletions(-)

diff --git a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestShowCLI.java b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestShowCLI.java
index bee9f841a557b4b768e17777ebcf51fa6bb31016..edabb2296db130c866605ef281d58b3e32420094 100644
--- a/base/java-tools/src/com/netscape/cmstools/cert/CertRequestShowCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cert/CertRequestShowCLI.java
@@ -19,7 +19,7 @@ public class CertRequestShowCLI extends CLI {
 
     @Override
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Request ID> [OPTIONS...]", options);
+        formatter.printHelp(parent.name + "-" + name + " <Request ID>", options);
     }
 
     @Override
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupAddMemberCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupAddMemberCLI.java
index 92766cf99720e547de3bf526521ffea81ee8e09c..36d3c06fd2f87f860ac26b1d5a5fb83960187059 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupAddMemberCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupAddMemberCLI.java
@@ -35,7 +35,7 @@ public class GroupAddMemberCLI extends CLI {
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Group ID> <Member ID> [OPTIONS...]", options);
+        formatter.printHelp(parent.name + "-" + name + " <Group ID> <Member ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveCLI.java
index 744f13b8c72f8bcd55723bad71c659c82b7b8b5b..fd9c08893d9d28ac38027b1be9da0c6466c1291b 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveCLI.java
@@ -35,7 +35,7 @@ public class GroupRemoveCLI extends CLI {
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Group ID> [OPTIONS...]", options);
+        formatter.printHelp(parent.name + "-" + name + " <Group ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveMemberCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveMemberCLI.java
index f46885631699411c2c714ec42365f9c9cff6cba3..c12cc892e5d0f0fdef107571c51c7b4b0a8c7d02 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveMemberCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveMemberCLI.java
@@ -34,7 +34,7 @@ public class GroupRemoveMemberCLI extends CLI {
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Group ID> <Member ID> [OPTIONS...]", options);
+        formatter.printHelp(parent.name + "-" + name + " <Group ID> <Member ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupShowCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupShowCLI.java
index 3209c2b37e52bb58b4ff2fcae5aa6f0d009e1dbb..4e8e444210e1978ac711768af0707fa79569c227 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupShowCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupShowCLI.java
@@ -35,7 +35,7 @@ public class GroupShowCLI extends CLI {
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Group ID> [OPTIONS...]", options);
+        formatter.printHelp(parent.name + "-" + name + " <Group ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupShowMemberCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupShowMemberCLI.java
index 8a4afb688bb1a6f305b52e4e33d90ba69868c492..47ca43c8f1a8d42a6261001c6b5d62cdc4240329 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupShowMemberCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupShowMemberCLI.java
@@ -35,7 +35,7 @@ public class GroupShowMemberCLI extends CLI {
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Group ID> <Member ID> [OPTIONS...]", options);
+        formatter.printHelp(parent.name + "-" + name + " <Group ID> <Member ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
diff --git a/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainGetInstallTokenCLI.java b/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainGetInstallTokenCLI.java
index 15b8def2a88d16680896c56a96f9c7d219b61895..2d21f733d79c6fe0ace74f95c9257c8d82873807 100644
--- a/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainGetInstallTokenCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/system/SecurityDomainGetInstallTokenCLI.java
@@ -40,7 +40,7 @@ public class SecurityDomainGetInstallTokenCLI extends CLI {
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name, options);
+        formatter.printHelp(parent.name + "-" + name + " [OPTIONS...]", options);
     }
 
     public void execute(String[] args) throws Exception {
diff --git a/base/java-tools/src/com/netscape/cmstools/user/UserAddMembershipCLI.java b/base/java-tools/src/com/netscape/cmstools/user/UserAddMembershipCLI.java
index e1b523ace915eef1fb1612057d59aaad4f205912..224f2266d319a788dc9c47eccffced9c68a07cb7 100644
--- a/base/java-tools/src/com/netscape/cmstools/user/UserAddMembershipCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/user/UserAddMembershipCLI.java
@@ -35,7 +35,7 @@ public class UserAddMembershipCLI extends CLI {
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <User ID> <Group ID> [OPTIONS...]", options);
+        formatter.printHelp(parent.name + "-" + name + " <User ID> <Group ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
diff --git a/base/java-tools/src/com/netscape/cmstools/user/UserRemoveCLI.java b/base/java-tools/src/com/netscape/cmstools/user/UserRemoveCLI.java
index 6bafba8a4689a48ed5d71173fab0f92d89abb1d7..e7a9ad5d178a569e917d703600118912b7edb2e2 100644
--- a/base/java-tools/src/com/netscape/cmstools/user/UserRemoveCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/user/UserRemoveCLI.java
@@ -34,7 +34,7 @@ public class UserRemoveCLI extends CLI {
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <User ID> [OPTIONS...]", options);
+        formatter.printHelp(parent.name + "-" + name + " <User ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
diff --git a/base/java-tools/src/com/netscape/cmstools/user/UserRemoveCertCLI.java b/base/java-tools/src/com/netscape/cmstools/user/UserRemoveCertCLI.java
index 203e48f524f8f6a7865e2e8f3b32abb3fb8ff368..264458b7f38a2fd150df30b2dc4dd6de49236dfa 100644
--- a/base/java-tools/src/com/netscape/cmstools/user/UserRemoveCertCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/user/UserRemoveCertCLI.java
@@ -37,7 +37,7 @@ public class UserRemoveCertCLI extends CLI {
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <User ID> <Cert ID> [OPTIONS...]", options);
+        formatter.printHelp(parent.name + "-" + name + " <User ID> <Cert ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
diff --git a/base/java-tools/src/com/netscape/cmstools/user/UserRemoveMembershipCLI.java b/base/java-tools/src/com/netscape/cmstools/user/UserRemoveMembershipCLI.java
index cab887a388c377f9a8bb13714a55bed55eab6b6c..26a5a6eec5222b98718df1f5a524d364970ac3ed 100644
--- a/base/java-tools/src/com/netscape/cmstools/user/UserRemoveMembershipCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/user/UserRemoveMembershipCLI.java
@@ -34,7 +34,7 @@ public class UserRemoveMembershipCLI extends CLI {
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <User ID> <Group ID> [OPTIONS...]", options);
+        formatter.printHelp(parent.name + "-" + name + " <User ID> <Group ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
diff --git a/base/java-tools/src/com/netscape/cmstools/user/UserShowCLI.java b/base/java-tools/src/com/netscape/cmstools/user/UserShowCLI.java
index 679b67791100a8f936703e88710455c005915931..a04cd6da283a5c5a1f91a2c5caca0f6b7b018526 100644
--- a/base/java-tools/src/com/netscape/cmstools/user/UserShowCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/user/UserShowCLI.java
@@ -35,7 +35,7 @@ public class UserShowCLI extends CLI {
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <User ID> [OPTIONS...]", options);
+        formatter.printHelp(parent.name + "-" + name + " <User ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
-- 
1.7.10.2